/********************************** (C) COPYRIGHT *******************************
* File Name          : main.c
* Author             : WCH
* Version            : V1.0.0
* Date               : 2021/08/08
* Description        : Main program body.
*********************************************************************************
* Copyright (c) 2021 Nanjing Qinheng Microelectronics Co., Ltd.
* Attention: This software (modified or not) and binary are used for
* microcontroller manufactured by Nanjing Qinheng Microelectronics.
*******************************************************************************/
#include "debug.h"
#include "FreeRTOS.h"
#include "task.h"

/* Global define */

#define TASK1_TASK_PRIO     5
#define TASK1_STK_SIZE      256
#define TASK2_TASK_PRIO     5
#define TASK2_STK_SIZE      256
#define TASK3_TASK_PRIO     5
#define TASK3_STK_SIZE      256

/* Global Variable */
TaskHandle_t Task1Task_Handler;
TaskHandle_t Task2Task_Handler;
TaskHandle_t Task3Task_Handler;

#define USART_REC_LEN  		20  						//ֽ 128
uint8_t USART_RX3_BUF[USART_REC_LEN];     //ջ,USART_REC_LENֽ.
uint8_t UART_RX4_BUF[USART_REC_LEN];     //ջ,USART_REC_LENֽ.
uint8_t UART_RX5_BUF[USART_REC_LEN];
uint8_t UART_RX6_BUF[USART_REC_LEN];
uint8_t UART_RX7_BUF[USART_REC_LEN];
uint8_t UART_RX8_BUF[USART_REC_LEN];

uint8_t RX[100];


/*********************************************************************
 * @fn      EXTI0_INT_INIT
 *
 * @brief   Initializes EXTI0 collection.
 *
 * @return  none
 */
void EXTI0_INT_INIT( void )
{
    GPIO_InitTypeDef  GPIO_InitStructure = {0};
    EXTI_InitTypeDef EXTI_InitStructure = {0};
    NVIC_InitTypeDef NVIC_InitStructure = {0};

    RCC_APB2PeriphClockCmd( RCC_APB2Periph_AFIO | RCC_APB2Periph_GPIOA, ENABLE );

    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_0;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IPU;
    GPIO_Init( GPIOA, &GPIO_InitStructure );

    /* GPIOA ----> EXTI_Line0 */
    GPIO_EXTILineConfig( GPIO_PortSourceGPIOA, GPIO_PinSource0 );
    EXTI_InitStructure.EXTI_Line = EXTI_Line0;
    EXTI_InitStructure.EXTI_Mode = EXTI_Mode_Interrupt;
    EXTI_InitStructure.EXTI_Trigger = EXTI_Trigger_Falling;
    EXTI_InitStructure.EXTI_LineCmd = ENABLE;
    EXTI_Init( &EXTI_InitStructure );

    NVIC_InitStructure.NVIC_IRQChannel = EXTI0_IRQn;
    NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 1;
    NVIC_InitStructure.NVIC_IRQChannelSubPriority = 2;
    NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
    NVIC_Init( &NVIC_InitStructure );
}

/*********************************************************************
 * @fn      USARTx_CFG
 *
 * @brief   Initializes the USART2 & USART3 peripheral.
 *
 * @return  none
 */
void USARTx_CFG( void )             //7ڳʼDMAok
{
    GPIO_InitTypeDef  GPIO_InitStructure = {0};
    USART_InitTypeDef USART_InitStructure = {0};
    NVIC_InitTypeDef  NVIC_InitStructure = {0};

    RCC_APB1PeriphClockCmd( RCC_APB1Periph_USART2|RCC_APB1Periph_USART3|RCC_APB1Periph_UART4|RCC_APB1Periph_UART5|RCC_APB1Periph_UART6|RCC_APB1Periph_UART7|RCC_APB1Periph_UART8, ENABLE);
    RCC_APB2PeriphClockCmd( RCC_APB2Periph_GPIOA|RCC_APB2Periph_GPIOB|RCC_APB2Periph_GPIOC|RCC_APB2Periph_GPIOD, ENABLE);

//    /* USART1 TX-->A.9  RX-->A.10 */
//    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_9;
//    GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
//    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;
//    GPIO_Init(GPIOA, &GPIO_InitStructure);
//    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_10;
//    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN_FLOATING;
//    GPIO_Init(GPIOA, &GPIO_InitStructure);
    /* USART2 TX-->A.2   RX-->A.3 */
    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_2;
    GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;
    GPIO_Init( GPIOA, &GPIO_InitStructure );
    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_3;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN_FLOATING;
    GPIO_Init( GPIOA, &GPIO_InitStructure );
    /* USART3 TX-->B.10  RX-->B.11 */
    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_10;
    GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;
    GPIO_Init( GPIOB, &GPIO_InitStructure );
    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_11;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN_FLOATING;
    GPIO_Init( GPIOB, &GPIO_InitStructure );
    /* UART4 TX-->C.10  RX-->C.11 */
    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_10;
    GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;
    GPIO_Init(GPIOC, &GPIO_InitStructure);
    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_11;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN_FLOATING;
    GPIO_Init(GPIOC, &GPIO_InitStructure);
    /* UART5 TX-->C.12  RX-->D.12 */
    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_12;
    GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;
    GPIO_Init(GPIOC, &GPIO_InitStructure);
    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_12;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN_FLOATING;
    GPIO_Init(GPIOD, &GPIO_InitStructure);
    /* UART6 TX-->C.0  RX-->C.1 */
    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_0;
    GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;
    GPIO_Init(GPIOC, &GPIO_InitStructure);
    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_1;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN_FLOATING;
    GPIO_Init(GPIOC, &GPIO_InitStructure);
    /* UART7 TX-->C.2  RX-->C.3 */
    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_2;
    GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;
    GPIO_Init(GPIOC, &GPIO_InitStructure);
    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_3;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN_FLOATING;
    GPIO_Init(GPIOC, &GPIO_InitStructure);
    /* UART8 TX-->C.4  RX-->C.5 */
    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_4;
    GPIO_InitStructure.GPIO_Speed = GPIO_Speed_50MHz;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_AF_PP;
    GPIO_Init(GPIOC, &GPIO_InitStructure);
    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_5;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_IN_FLOATING;
    GPIO_Init(GPIOC, &GPIO_InitStructure);


    USART_InitStructure.USART_BaudRate = 115200;
    USART_InitStructure.USART_WordLength = USART_WordLength_9b;
    USART_InitStructure.USART_StopBits = USART_StopBits_1;
    USART_InitStructure.USART_Parity = USART_Parity_No;
    USART_InitStructure.USART_HardwareFlowControl = USART_HardwareFlowControl_None;
    USART_InitStructure.USART_Mode = USART_Mode_Tx | USART_Mode_Rx;

//    USART_Init(USART1, &USART_InitStructure);
//    USART_ITConfig(USART1, USART_IT_RXNE, ENABLE);
    USART_Init(USART2, &USART_InitStructure);
    USART_ITConfig(USART2, USART_IT_RXNE, DISABLE);//ʼȫر
    USART_Init(USART3, &USART_InitStructure);
    USART_ITConfig(USART3, USART_IT_RXNE, DISABLE);
    USART_Init(UART4, &USART_InitStructure);
    USART_ITConfig(UART4, USART_IT_RXNE, ENABLE);
    USART_Init(UART5, &USART_InitStructure);
    USART_ITConfig(UART5, USART_IT_RXNE, ENABLE);
    USART_Init(UART6, &USART_InitStructure);
    USART_ITConfig(UART6, USART_IT_RXNE, ENABLE);
    USART_Init(UART7, &USART_InitStructure);
    USART_ITConfig(UART7, USART_IT_RXNE, ENABLE);
    USART_Init(UART8, &USART_InitStructure);
    USART_ITConfig(UART8, USART_IT_RXNE, ENABLE);

//    NVIC_InitStructure.NVIC_IRQChannel = USART1_IRQn;
//    NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 2;
//    NVIC_InitStructure.NVIC_IRQChannelSubPriority = 2;
//    NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
//    NVIC_Init(&NVIC_InitStructure);
    NVIC_InitStructure.NVIC_IRQChannel = USART2_IRQn;
    NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 2;
    NVIC_InitStructure.NVIC_IRQChannelSubPriority = 2;
    NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
    NVIC_Init(&NVIC_InitStructure);
    NVIC_InitStructure.NVIC_IRQChannel = USART3_IRQn;
    NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 2;
    NVIC_InitStructure.NVIC_IRQChannelSubPriority = 2;
    NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
    NVIC_Init(&NVIC_InitStructure);
    NVIC_InitStructure.NVIC_IRQChannel = UART4_IRQn;
    NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 2;
    NVIC_InitStructure.NVIC_IRQChannelSubPriority = 2;
    NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
    NVIC_Init(&NVIC_InitStructure);
    NVIC_InitStructure.NVIC_IRQChannel = UART5_IRQn;
    NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 2;
    NVIC_InitStructure.NVIC_IRQChannelSubPriority = 2;
    NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
    NVIC_Init(&NVIC_InitStructure);
    NVIC_InitStructure.NVIC_IRQChannel = UART6_IRQn;
    NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 2;
    NVIC_InitStructure.NVIC_IRQChannelSubPriority = 2;
    NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
    NVIC_Init(&NVIC_InitStructure);
    NVIC_InitStructure.NVIC_IRQChannel = UART7_IRQn;
    NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 2;
    NVIC_InitStructure.NVIC_IRQChannelSubPriority = 2;
    NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
    NVIC_Init(&NVIC_InitStructure);
    NVIC_InitStructure.NVIC_IRQChannel = UART8_IRQn;
    NVIC_InitStructure.NVIC_IRQChannelPreemptionPriority = 2;
    NVIC_InitStructure.NVIC_IRQChannelSubPriority = 2;
    NVIC_InitStructure.NVIC_IRQChannelCmd = ENABLE;
    NVIC_Init(&NVIC_InitStructure);



//    USART_Cmd(USART1, ENABLE);
    USART_Cmd(USART2, ENABLE);
    USART_Cmd(USART3, ENABLE);
    USART_Cmd(UART4, ENABLE);
    USART_Cmd(UART5, ENABLE);
    USART_Cmd(UART6, ENABLE);
    USART_Cmd(UART7, ENABLE);
    USART_Cmd(UART8, ENABLE);

//     DMA_Cmd(DMA1_Channel5, ENABLE); /* USART1 Rx */   //bilibili DMA
//     DMA_Cmd(DMA1_Channel4, ENABLE);

//    USART_SetAddress( USART2, 0x1 );
//    USART_SetAddress( USART3, 0x2 );
//    USART_WakeUpConfig( USART3, USART_WakeUp_AddressMark );
//    USART_ReceiverWakeUpCmd( USART3, ENABLE );                    /* USART3 Into Silence */
}
/*********************************************************************
 * @fn      GPIO_Toggle_INIT
 *
 * @brief   Initializes GPIOA.0/1
 *
 * @return  none
 */
void GPIO_Toggle_INIT(void)         //LEDƳʼ ok
{
    GPIO_InitTypeDef  GPIO_InitStructure= {0};

    RCC_APB2PeriphClockCmd(RCC_APB2Periph_GPIOB,ENABLE);
    GPIO_InitStructure.GPIO_Pin = GPIO_Pin_12;
    GPIO_InitStructure.GPIO_Mode = GPIO_Mode_Out_PP;
    GPIO_InitStructure.GPIO_Speed=GPIO_Speed_50MHz;
    GPIO_Init(GPIOB, &GPIO_InitStructure);
}

uint16_t USART_RX3_STA=0;       //״̬
uint16_t UART_RX4_STA=0;       //״̬
uint16_t UART_RX5_STA=0;       //״̬
uint16_t UART_RX6_STA=0;
uint16_t UART_RX7_STA=0;
uint16_t UART_RX8_STA=0;


/*********************************************************************
 * @fn      жϽ
 */
void USART_Receive(USART_TypeDef *USARTx, uint16_t USART_RXx_STA,uint8_t USART_RXx_BUF[])
{
    uint8_t t=0,reclen=0; //ݳ;
    uint8_t Res=0;
    if( USART_GetFlagStatus( USARTx, USART_FLAG_RXNE ) != RESET )
    {
        /* receive data */
        Res = USART_ReceiveData(USARTx);  		//ȡյ
        if((USART_RXx_STA&0x8000)==0)						//δ
        {
            if(USART_RXx_STA&0x4000)								//յ0x0d
            {
                if(Res!=0x0a)
                    USART_RXx_STA=0;			//մ,¿ʼ
                else 
                    USART_RXx_STA|=0x8000;				//
            }
            else //ûյ0X0D
            {
                if(Res==0x0d)               //յ0x0d
                    USART_RXx_STA|=0x4000;
                else
                {
                    USART_RXx_BUF[USART_RXx_STA&0X3FFF]=Res ;
                    USART_RXx_STA++;
                    if(USART_RXx_STA>(USART_REC_LEN-1))
                        USART_RXx_STA=0;//ݴ,¿ʼ
                }
            }
        }
    }
    if(USARTx == USART3)
    {
        USART_RX3_STA=USART_RXx_STA;
        for( t=0; t<reclen; t++)
        {
            USART_RX3_BUF[t]=USART_RXx_BUF[t];
        }
    }
    if(USARTx == UART4)
    {
        UART_RX4_STA=USART_RXx_STA;
        for( t=0; t<reclen; t++)
        {
            UART_RX4_BUF[t]=USART_RXx_BUF[t];
        }
    }
    if(USARTx == UART5)
    {
        UART_RX5_STA=USART_RXx_STA;
        for( t=0; t<reclen; t++)
        {
            UART_RX5_BUF[t]=USART_RXx_BUF[t];
        }
    }
    if(USARTx == UART6)
    {
        UART_RX6_STA=USART_RXx_STA;
        for( t=0; t<reclen; t++)
        {
            UART_RX6_BUF[t]=USART_RXx_BUF[t];
        }
    }
    if(USARTx == UART7)
    {
        UART_RX7_STA=USART_RXx_STA;
        for( t=0; t<reclen; t++)
        {
            UART_RX7_BUF[t]=USART_RXx_BUF[t];
        }
    }
    if(USARTx == UART8)
    {
        UART_RX8_STA=USART_RXx_STA;
        for( t=0; t<reclen; t++)
        {
            UART_RX8_BUF[t]=USART_RXx_BUF[t];
        }
    }
}

/*********************************************************************
 * @fn      ʱѭɨ跢
 */
uint16_t USART_Analze_Receive(USART_TypeDef *USARTx, uint16_t USART_RXx_STA,uint8_t USART_RXx_BUF[])
{
    uint8_t reclen=0; //ݳ;
    if(USART_RXx_STA&0X8000)												//յһ
    {
        reclen=USART_RXx_STA&0X7FFF;										//õݳ
        USART_RXx_BUF[reclen]=0;	 										//

        if(USART_RXx_BUF[reclen-6] == 0x23 & USART_RXx_BUF[reclen-5] == 0x24 & USART_RXx_BUF[reclen-1] == 0xFF )  //& USART_RXx_BUF[reclen-4] < 0xFE
        {
            if(USARTx == USART3)
            {
                RX[0]=USART_RXx_BUF[reclen-4];
                RX[1]=USART_RXx_BUF[reclen-3];
                RX[2]=USART_RXx_BUF[reclen-2];
            }
            if(USARTx == UART4)
            {
                RX[3]=USART_RXx_BUF[reclen-4];
                RX[4]=USART_RXx_BUF[reclen-3];
                RX[5]=USART_RXx_BUF[reclen-2];
            }
            if(USARTx == UART5)
            {
                RX[6]=USART_RXx_BUF[reclen-4];
                RX[7]=USART_RXx_BUF[reclen-3];
                RX[8]=USART_RXx_BUF[reclen-2];
            }
            if(USARTx == UART6)
            {
                RX[9]=USART_RXx_BUF[reclen-4];
                RX[10]=USART_RXx_BUF[reclen-3];
                RX[11]=USART_RXx_BUF[reclen-2];
            }
            if(USARTx == UART7)
            {
                RX[12]=USART_RXx_BUF[reclen-4];
                RX[13]=USART_RXx_BUF[reclen-3];
                RX[14]=USART_RXx_BUF[reclen-2];
            }
            if(USARTx == UART8)
            {
                RX[15]=USART_RXx_BUF[reclen-4];
                RX[16]=USART_RXx_BUF[reclen-3];
                RX[17]=USART_RXx_BUF[reclen-2];
            }
        }
//        USART_RXx_STA=0;
    }
    return 0;
}
/*********************************************************************
 * @fn      task1_task
 *
 * @brief   task1 program.
 *
 * @param  *pvParameters - Parameters point of task1
 *
 * @return  none
 */
void PWR_task(void *pvParameters)
{
    UBaseType_t msticks=0;
    msticks = pdMS_TO_TICKS(100);
    while(1)
    {
        GPIO_SetBits(GPIOB, GPIO_Pin_12);
        vTaskDelay(msticks);
        GPIO_ResetBits(GPIOB, GPIO_Pin_12);
        vTaskDelay(msticks);
    }
}



void task1_task(void *pvParameters)
{
    UBaseType_t msticks=0;
    msticks = pdMS_TO_TICKS(10);
    uint8_t i=0;
    while(1)
    {
//        printf("task1 entry\r\n");
//        printf("Count=%d,rx3=%d,\r\n",Send_count++,RX[0]);
        
        USART_RX3_STA=USART_Analze_Receive(USART3, USART_RX3_STA,USART_RX3_BUF);
        UART_RX4_STA=USART_Analze_Receive(UART4, UART_RX4_STA,UART_RX4_BUF);
        UART_RX5_STA=USART_Analze_Receive(UART5, UART_RX5_STA,UART_RX5_BUF);
        UART_RX6_STA=USART_Analze_Receive(UART6, UART_RX6_STA,UART_RX6_BUF);
        UART_RX7_STA=USART_Analze_Receive(UART7, UART_RX7_STA,UART_RX7_BUF);
        UART_RX8_STA=USART_Analze_Receive(UART8, UART_RX8_STA,UART_RX8_BUF);
        
        USART_SendData( USART2, 0X23 );
        while( USART_GetFlagStatus( USART2, USART_FLAG_TXE ) == RESET ) {}
        USART_SendData( USART2, 0X24 );
        while( USART_GetFlagStatus( USART2, USART_FLAG_TXE ) == RESET ) {}
        for(i=0; i<18; i++)
        {
            USART_SendData( USART2, RX[i] );
            while( USART_GetFlagStatus( USART2, USART_FLAG_TXE ) == RESET ) {}
        }
        USART_SendData( USART2, 0XFF );
        while( USART_GetFlagStatus( USART2, USART_FLAG_TXE ) == RESET ) {}
        USART_SendData( USART2, 0X0D );
        while( USART_GetFlagStatus( USART2, USART_FLAG_TXE ) == RESET ) {}
        USART_SendData( USART2, 0X0A );
        while( USART_GetFlagStatus( USART2, USART_FLAG_TXE ) == RESET ) {}

//        USART_SendData( USART2, 0x02 );
//        while( USART_GetFlagStatus( USART2, USART_FLAG_TXE ) == RESET ) {}
//        USART_SendData( USART3, 0x03 );
//        while( USART_GetFlagStatus( USART2, USART_FLAG_TXE ) == RESET ) {}
//        USART_SendData( UART4, 0x04 );
//        while( USART_GetFlagStatus( USART2, USART_FLAG_TXE ) == RESET ) {}
//        USART_SendData( UART5, 0x05 );
//        while( USART_GetFlagStatus( USART2, USART_FLAG_TXE ) == RESET ) {}
//        USART_SendData( UART6, 0x06);
//        while( USART_GetFlagStatus( USART2, USART_FLAG_TXE ) == RESET ) {}
//        USART_SendData( UART7, 0x07 );
//        while( USART_GetFlagStatus( USART2, USART_FLAG_TXE ) == RESET ) {}
//        USART_SendData( UART8, 0x08 );
//        while( USART_GetFlagStatus( USART2, USART_FLAG_TXE ) == RESET ) {}
        vTaskDelay(msticks);
    }

}

/*********************************************************************
 * @fn      task2_task
 *
 * @brief   task2 program.
 *
 * @param  *pvParameters - Parameters point of task2
 *
 * @return  none
 */


//ж(յݱ0x0d 0x0aβ)
void task2_task(void *pvParameters)
{
//uint8_t Res;
    UBaseType_t msticks=0;
    msticks = pdMS_TO_TICKS(10);       
    while(1)
    {      vTaskDelay(msticks);         
//        USART_Receive(USART3, USART_RX3_STA,USART_RX3_BUF);
//        USART_Receive(UART4, UART_RX4_STA,UART_RX4_BUF);
//        USART_Receive(UART5, UART_RX5_STA,UART_RX5_BUF);
//        USART_Receive(UART6, UART_RX6_STA,UART_RX6_BUF);
//        USART_Receive(UART7, UART_RX7_STA,UART_RX7_BUF);
//        USART_Receive(UART8, UART_RX8_STA,UART_RX8_BUF);
        
//        if(USART_RX3_STA&0X8000)												//յһ
//        {
//            reclen=USART_RX3_STA&0X7FFF;										//õݳ
//            USART_RX3_BUF[reclen]=0;	 										//
//            if(USART_RX3_BUF[0] == 0x23 & USART_RX3_BUF[1] == 0x24)
//            {
//                RX[0]=USART_RX3_BUF[2];
//                RX[1]=USART_RX3_BUF[3];
//                RX[2]=USART_RX3_BUF[4];
////                for( t=2; t<reclen; t++)
////                {
////                    USART_SendData( USART2, USART_RX_BUF[t] );
////                    while( USART_GetFlagStatus( USART2, USART_FLAG_TXE ) == RESET ) {}
////                }
//            }
////			printf("reclen:%d\r\n",reclen);
//            USART_RX3_STA=0;
//        }
//        if(UART_RX4_STA&0X8000)												//յһ
//        {
//            if(UART_RX4_BUF[0] == 0x23 & UART_RX4_BUF[1] == 0x24)
//            {
//                RX[3]=UART_RX4_BUF[2];
//                RX[4]=UART_RX4_BUF[3];
//                RX[5]=UART_RX4_BUF[4];

//            }

//            UART_RX4_STA=0;
//        }

    }
}
/*********************************************************************
 * @fn      main
 *
 * @brief   Main program.
 *
 * @return  none
 */
int main(void)
{
    NVIC_PriorityGroupConfig(NVIC_PriorityGroup_2);
    SystemCoreClockUpdate();
    USART_Printf_Init(115200);
    printf("SystemClk:%d\r\n",SystemCoreClock);
    printf( "ChipID:%08x\r\n", DBGMCU_GetCHIPID() );
    printf("FreeRTOS Kernel Version:%s\r\n",tskKERNEL_VERSION_NUMBER);
//    DMA_INIT();          //bilibili
//    EXTI0_INT_INIT();
    GPIO_Toggle_INIT();
    USARTx_CFG();

    /* create two task */
    xTaskCreate((TaskFunction_t )task2_task,
                (const char*    )"task2",
                (uint16_t       )TASK2_STK_SIZE,
                (void*          )NULL,
                (UBaseType_t    )TASK2_TASK_PRIO,
                (TaskHandle_t*  )&Task2Task_Handler);

    xTaskCreate((TaskFunction_t )task1_task,
                (const char*    )"task1",
                (uint16_t       )TASK1_STK_SIZE,
                (void*          )NULL,
                (UBaseType_t    )TASK1_TASK_PRIO,
                (TaskHandle_t*  )&Task1Task_Handler);


    xTaskCreate((TaskFunction_t )PWR_task,
                (const char*    )"pwr",
                (uint16_t       )TASK3_STK_SIZE,
                (void*          )NULL,
                (UBaseType_t    )TASK3_TASK_PRIO,
                (TaskHandle_t*  )&Task3Task_Handler);

    vTaskStartScheduler();

    while(1)
    {
        printf("shouldn't run at here!!\n");
    }
}


void EXTI0_IRQHandler( void )
{
    if( EXTI_GetITStatus( EXTI_Line0 ) != RESET )
    {
        printf( "Run at EXTI\r\n" );
        EXTI_ClearITPendingBit( EXTI_Line0 );   /* Clear Flag */
    }
}



void UART4_IRQHandler( void )
{
    USART_Receive(UART4, UART_RX4_STA,UART_RX4_BUF);
}
void UART5_IRQHandler( void )
{
    USART_Receive(UART5, UART_RX5_STA,UART_RX5_BUF);
}
void UART6_IRQHandler( void )
{
    USART_Receive(UART6, UART_RX6_STA,UART_RX6_BUF);
}
void UART7_IRQHandler( void )
{
    USART_Receive(UART7, UART_RX7_STA,UART_RX7_BUF);
}
void UART8_IRQHandler( void )
{
    USART_Receive(UART8, UART_RX8_STA,UART_RX8_BUF);
}
